## kwave 20.12.2

=== CMakeLists.txt ===
#############################################################################
##    Kwave                - CMakeLists.txt
##                           -------------------
##    begin                : Tue May 01 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

# KDE Application Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "20")
set (RELEASE_SERVICE_VERSION_MINOR "12")
set (RELEASE_SERVICE_VERSION_MICRO "2")

#############################################################################
### build options:                                                        ###

# OPTION(DEBUG           "build debug code [default=off]" OFF)
# OPTION(WITH_ALSA       "enable playback/recording via ALSA [default=on]" ON)
# OPTION(WITH_DOC        "build online documentation [default=on]" ON)
# OPTION(WITH_FLAC       "enable support for FLAC files [default=on]" ON)
# OPTION(WITH_MP3        "enable support for mp3 files [default=off]" OFF)
# OPTION(WITH_OGG_OPUS   "enable support for ogg/opus files [default=on]" ON)
# OPTION(WITH_OGG_VORBIS "enable support for ogg/vorbis files [default=on]" ON)
# OPTION(WITH_OSS        "enable playback/recording via OSS [default=on]" ON)
# OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
# OPTION(WITH_PULSEAUDIO "enable playback/recording via PulseAudio [default=on]" ON)
# OPTION(WITH_QT_AUDIO   "enable playback via Qt Multimedia [default=on]" ON)

#############################################################################
### toplevel build targets:                                               ###

# all                 - default target, build all files
# clean               - clean up the current build directory
# deb                 - create a debian package
# doc                 - generate docbook files for online help
# distfiles           - generate subdirectory with all files for distribution
# html_doc            - generate HTML help (for the web)
# install             - install the package, with support for DESTDIR
# msgstats            - show the progress of translations
# rpm                 - create a RPM package + a src.rpm file
# src_rpm             - create the source RPM only
# tarball             - create a tar.bz2 archive with the sources + specfile
# uninstall           - uninstall the package, with support for DESTDIR
# update-translations - update translation files from KDE SVN
# version-labels      - update all version numbers and build dates
# tarball             - create a tar.gz file with the sources

#############################################################################
### required versions                                                     ###

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)

# Honor visibility properties for all target types (since cmake 3.3)
IF (POLICY CMP0063)
    CMAKE_POLICY(SET CMP0063 NEW)
ENDIF (POLICY CMP0063)

# exclude generated automoc files per default (since cmake 3.10)
IF (POLICY CMP0071)
    CMAKE_POLICY(SET CMP0071 NEW)
ENDIF (POLICY CMP0071)

# include file check macros honor CMAKE_REQUIRED_LIBRARIES (since cmake 3.12)
IF (POLICY CMP0075)
    CMAKE_POLICY(SET CMP0075 NEW)
ENDIF (POLICY CMP0075)

# Set policy for the VERSION inside PROJECT
IF (POLICY CMP0048)
    CMAKE_POLICY(SET CMP0048 NEW)
ENDIF (POLICY CMP0048)

SET(ECM_MIN_VERSION "1.7.0")
SET(QT_MIN_VERSION  "5.14.0")
SET(KF5_MIN_VERSION "5.33.0")

#############################################################################
### Kwave version number                                                  ###

SET(KWAVE_VERSION_MAJOR ${RELEASE_SERVICE_VERSION_MAJOR})
SET(KWAVE_VERSION_MINOR ${RELEASE_SERVICE_VERSION_MINOR})
SET(KWAVE_VERSION_MICRO ${RELEASE_SERVICE_VERSION_MICRO})
SET(KWAVE_VERSION "${KWAVE_VERSION_MAJOR}.${KWAVE_VERSION_MINOR}.${KWAVE_VERSION_MICRO}")
MESSAGE(STATUS "Building Kwave version ${KWAVE_VERSION}")

#############################################################################
### project name and version                                              ###

PROJECT(kwave VERSION ${KWAVE_VERSION})

#############################################################################
### show the compiler name and version                                    ###

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -dumpversion
    OUTPUT_VARIABLE COMPILER_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
GET_FILENAME_COMPONENT(COMPILER_SHORT "${CMAKE_C_COMPILER}" NAME_WE CACHE)
MESSAGE(STATUS "Building with ${COMPILER_SHORT} version ${COMPILER_VERSION}")

#############################################################################
### check for the CPU we build for                                        ###

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -dumpmachine
    OUTPUT_VARIABLE MACHINE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
MESSAGE(STATUS "Building for target ${MACHINE}")

OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
IF (WITH_OPTIMIZED_MEMCPY)

    STRING(REGEX MATCH "(i.86-*)|(athlon-*)|(pentium-*)" _mach_x86 ${MACHINE})
    IF (_mach_x86)
        MESSAGE(STATUS "Found target optimized memcpy() for X86 (from xine)")
        SET(ARCH_X86 1)
    ENDIF (_mach_x86)

    STRING(REGEX MATCH "(x86_64-*)|(X86_64-*)|(AMD64-*)|(amd64-*)" _mach_x86_64 ${MACHINE})
    IF (_mach_x86_64)
        MESSAGE(STATUS "Found target optimized memcpy() for X86_64 (from xine)")
        SET(ARCH_X86_64 1)
    ENDIF (_mach_x86_64)

    STRING(REGEX MATCH "(ppc-*)|(powerpc-*)" _mach_ppc ${MACHINE})
    IF (_mach_ppc)
        MESSAGE(STATUS "Found target optimized memcpy() for PPC (from xine)")
        SET(ARCH_PPC 1)
    ENDIF (_mach_ppc)

    IF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)
        MESSAGE(STATUS "No platform specific memcpy available")
    ENDIF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)

ELSE (WITH_OPTIMIZED_MEMCPY)
    MESSAGE(STATUS "Platform specific memcpy is disabled")
ENDIF (WITH_OPTIMIZED_MEMCPY)

#############################################################################
### path to additional cmake modules and includes                         ###

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

#############################################################################
### cmake includes                                                        ###

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckIncludeFilesCXX)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(CheckTypeSize)
INCLUDE(CheckFunctionExists)
INCLUDE(FindRequiredProgram)

#############################################################################
### toplevel compiler flags                                               ###

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DQT_NO_CAST_TO_ASCII)
ADD_DEFINITIONS(-DQT_NO_CAST_FROM_ASCII)
ADD_DEFINITIONS(-DQT_USE_FAST_OPERATOR_PLUS)
ADD_DEFINITIONS(-DQT_NO_URL_CAST_FROM_STRING)
ADD_DEFINITIONS(-DQT_DEPRECATED_WARNINGS)
ADD_DEFINITIONS(-DKXMLGUI_NO_DEPRECATED)

CHECK_C_COMPILER_FLAG(" ${CMAKE_SHARED_LIBRARY_C_FLAGS}" C_HAVE_PIC)
CHECK_CXX_COMPILER_FLAG(" ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}" CXX_HAVE_PIC)
IF (CXX_HAVE_PIC AND C_HAVE_PIC)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
ELSE (CXX_HAVE_PIC AND C_HAVE_PIC)
    MESSAGE(FATAL_ERROR "shared library support is missing")
ENDIF (CXX_HAVE_PIC AND C_HAVE_PIC)

CHECK_CXX_COMPILER_FLAG("--std=c++11" CXX_HAVE_CXX11)
IF (CXX_HAVE_CXX11)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11")
ENDIF (CXX_HAVE_CXX11)

#############################################################################

LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/libgui)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/libkwave)

#############################################################################
### Qt 5 support                                                          ###

SET(CMAKE_AUTOMOC TRUE)
SET(CMAKE_AUTOMOC_RELAXED_MODE FALSE)

FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Concurrent
    Core
    Widgets
)

# NOTE: this must be *after* FIND_PACKAGE(Qt5 Core ...), otherwise it would
#       be overwritten and produce many annoying build warnings
LIST(APPEND CMAKE_AUTOMOC_MACRO_NAMES "KWAVE_PLUGIN")

# Qt Multimedia support
OPTION(WITH_QT_AUDIO "enable playback via Qt Multimedia [default=on]" ON)
IF (WITH_QT_AUDIO)
    SET(HAVE_QT_AUDIO_SUPPORT on)
    FIND_PACKAGE(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
        Multimedia
    )
ENDIF (WITH_QT_AUDIO)


#############################################################################
### KF5 support                                                           ###

FIND_PACKAGE(ECM ${ECM_MIN_VERSION} REQUIRED NO_MODULE)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH}  )

INCLUDE(KDEInstallDirs)
INCLUDE(KDECompilerSettings)
INCLUDE(KDECMakeSettings)
INCLUDE(GenerateExportHeader)
INCLUDE(FeatureSummary)

FIND_PACKAGE(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Completion
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    DocTools
    I18n
    IconThemes
    KIO
    Service
    TextWidgets
    XmlGui
    WidgetsAddons
)

IF (NOT WITH_DOC)
    SET_PACKAGE_PROPERTIES(KF5DocTools
        PROPERTIES DESCRIPTION "Tools to generate documentation"
        TYPE OPTIONAL
    )
ENDIF (NOT WITH_DOC)

FEATURE_SUMMARY(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

INCLUDE_DIRECTORIES(
    ${INTERFACE_INCLUDE_DIRECTORIES}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

#############################################################################
### checks for needed header files                                        ###

CHECK_INCLUDE_FILES(signal.h HAVE_SIGNAL_H)

SET(_inc_c errno.h math.h signal.h stdlib.h string.h unistd.h pthread.h)
CHECK_INCLUDE_FILES("${_inc_c}" HAVE_REQUIRED_STD_C_HEADERS)
IF (NOT HAVE_REQUIRED_STD_C_HEADERS)
    MESSAGE(FATAL_ERROR "
        unable to find one or more of the following C header files:
        ${_inc_c}")
ENDIF (NOT HAVE_REQUIRED_STD_C_HEADERS)

SET(_inc_cpp algorithm complex limits new)
CHECK_INCLUDE_FILES_CXX("${_inc_cpp}")

#############################################################################
### checks for some functions                                             ###

CHECK_FUNCTION_EXISTS(unlink HAVE_UNLINK)

#############################################################################
### libaudiofile and libsamplerate support                                ###

INCLUDE(KwaveLibaudiofileSupport)
INCLUDE(KwaveLibsamplerateSupport)

=== libkwave/CMakeLists.txt ===
#############################################################################
##    Kwave                - libkwave/CMakeLists.txt
##                           -------------------
##    begin                : Tue May 01 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

#############################################################################

IF (WITH_OPTIMIZED_MEMCPY)

    # use "default" visibility for memcpy.c (which is our one and only C file)
    SET(CMAKE_C_VISIBILITY_PRESET default)

    CHECK_INCLUDE_FILES(sys/times.h HAVE_SYS_TIMES_H)

    SET(_inc_c stdint.h stdio.h)
    CHECK_INCLUDE_FILES("${_inc_c}" HAVE_REQUIRED_STD_C_HEADERS)
    IF (NOT HAVE_REQUIRED_STD_C_HEADERS)
	MESSAGE(FATAL_ERROR "
	    unable to find one or more of the following C header files:
	    ${_inc_c}")
    ENDIF (NOT HAVE_REQUIRED_STD_C_HEADERS)

    SET(libkwave_LIB_SRCS_memcpy cpu_accel.cpp memcpy.c)

    SET(_try_src_dir "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp")
    SET(_try_avx_assembler "${_try_src_dir}/cmake_try_avx_assembler.c")
    WRITE_FILE("${_try_avx_assembler}" "
	int main()
	{
	    __asm __volatile(\"vmovaps %ymm1, %ymm0\");
	    return 0;
	}
    ")
    MESSAGE(STATUS "Detecting compiler support for AVX inline assembler")
    TRY_COMPILE(HAVE_AVX ${CMAKE_BINARY_DIR} ${_try_avx_assembler} OUTPUT_VARIABLE _out)
    IF (HAVE_AVX)
	MESSAGE(STATUS "Detecting compiler support for AVX inline assembler - Success")
    ELSE (HAVE_AVX)
	MESSAGE(STATUS "Detecting compiler support for AVX inline assembler - not available")
    ENDIF (HAVE_AVX)

ENDIF (WITH_OPTIMIZED_MEMCPY)

SET(libkwave_LIB_SRCS
    ClipBoard.cpp
    CodecBase.cpp
    CodecManager.cpp
    CodecPlugin.cpp
    Compression.cpp
    ConfirmCancelProxy.cpp
    Connect.cpp
    Curve.cpp
    Decoder.cpp
    Drag.cpp
    Encoder.cpp
    Filter.cpp
    FileInfo.cpp
    FileProgress.cpp
    Functions.cpp
    GenreType.cpp
    GlobalLock.cpp
    Interpolation.cpp
    Label.cpp
    LabelList.cpp
    Logger.cpp
    MessageBox.cpp
    MetaData.cpp
    MetaDataList.cpp
    MimeData.cpp
    MixerMatrix.cpp
    MultiPlaybackSink.cpp
    MultiStreamWriter.cpp
    MultiTrackReader.cpp
    MultiTrackWriter.cpp
    MultiWriter.cpp
    Parser.cpp
    PlaybackController.cpp
    PlaybackSink.cpp
    PlayBackTypesMap.cpp
    Plugin.cpp
    PluginManager.cpp
    SampleArray.cpp
    SampleSink.cpp
    SampleSource.cpp
    Selection.cpp
    Signal.cpp
    SignalManager.cpp
    SampleEncoderLinear.cpp
    SampleFIFO.cpp
    SampleFormat.cpp
    SampleReader.cpp
    StandardBitrates.cpp
    StreamWriter.cpp
    Stripe.cpp
    Track.cpp
    TrackWriter.cpp
    Utils.cpp
    VirtualAudioFile.cpp
    VorbisCommentMap.cpp
    Writer.cpp
    WorkerThread.cpp
    WindowFunction.cpp

    modules/ChannelMixer.cpp
    modules/CurveStreamAdapter.cpp
    modules/Indexer.cpp
    modules/Delay.cpp
    modules/Mul.cpp
    modules/Osc.cpp
    modules/RateConverter.cpp
    modules/SampleBuffer.cpp
    modules/StreamObject.cpp

    undo/UndoAddMetaDataAction.cpp
    undo/UndoDeleteAction.cpp
    undo/UndoDeleteMetaDataAction.cpp
    undo/UndoDeleteTrack.cpp
    undo/UndoInsertAction.cpp
    undo/UndoInsertTrack.cpp
    undo/UndoManager.cpp
    undo/UndoModifyAction.cpp
    undo/UndoModifyMetaDataAction.cpp
    undo/UndoSelection.cpp
    undo/UndoTransaction.cpp
    undo/UndoTransactionGuard.cpp

    ${libkwave_LIB_SRCS_samplerate}
    ${libkwave_LIB_SRCS_memcpy}
)

#############################################################################

ADD_LIBRARY(libkwave SHARED ${libkwave_LIB_SRCS})

TARGET_LINK_LIBRARIES(libkwave
    audiofile
    ${SAMPLERATE_LIBS}
    Qt5::Core
    Qt5::Concurrent
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::I18n
    KF5::Service
    KF5::WidgetsAddons
    KF5::XmlGui
    pthread
)

#############################################################################

SET_TARGET_PROPERTIES(libkwave PROPERTIES OUTPUT_NAME "kwave")
SET_TARGET_PROPERTIES(libkwave PROPERTIES LINK_FLAGS "-Wl,--export-dynamic")
SET_TARGET_PROPERTIES(libkwave PROPERTIES
    VERSION ${KWAVE_VERSION} SOVERSION ${KWAVE_VERSION_MAJOR} )
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

#############################################################################
### install files                                                         ###

INSTALL(TARGETS libkwave LIBRARY DESTINATION ${LIB_INSTALL_DIR} NAMELINK_SKIP)

#############################################################################
#############################################################################

=== plugins/amplifyfree/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/amplifyfree/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_amplifyfree_LIB_SRCS
    AmplifyFreeDialog.cpp
    AmplifyFreePlugin.cpp
)

SET(plugin_amplifyfree_LIB_UI
    AmplifyFreeDlg.ui
)

KWAVE_PLUGIN(amplifyfree)

#############################################################################
#############################################################################

=== plugins/codec_audiofile/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_audiofile/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_codec_audiofile_LIB_SRCS
    AudiofileCodecPlugin.cpp
    AudiofileDecoder.cpp
)

SET(plugin_codec_audiofile_LIBS audiofile)

KWAVE_PLUGIN(codec_audiofile)

#############################################################################
#############################################################################

=== plugins/codec_flac/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_flac/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

OPTION(WITH_FLAC "enable support for FLAC files [default=on]" ON)
IF (WITH_FLAC)

    INCLUDE(CheckLibraryExists)

    PKG_CHECK_MODULES(FLAC REQUIRED flac>=1.2.0)
    MESSAGE(STATUS "Found FLAC version ${FLAC_VERSION}")

#############################################################################
### check for FLAC header files                                           ###

    SET(CMAKE_REQUIRED_INCLUDES ${FLAC_INCLUDEDIR})
    CHECK_INCLUDE_FILES(FLAC/format.h HAVE_FLAC_HEADERS)
    IF (NOT HAVE_FLAC_HEADERS)
        MESSAGE(FATAL_ERROR "libFLAC not found, please install libflac !")
    ENDIF (NOT HAVE_FLAC_HEADERS)

#############################################################################
### check for FLAC++ header files                                         ###

    CHECK_INCLUDE_FILES_CXX("FLAC++/decoder.h;FLAC++/metadata.h")

    SET(HAVE_FLAC  ON CACHE BOOL "enable FLAC codec")
    SET(plugin_codec_flac_LIB_SRCS
        FlacCodecPlugin.cpp
        FlacDecoder.cpp
        FlacEncoder.cpp
    )

    SET(plugin_codec_flac_LIBS FLAC++ FLAC)

    KWAVE_PLUGIN(codec_flac)

ENDIF(WITH_FLAC)

#############################################################################
#############################################################################

=== plugins/goto/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/goto/CMakeLists.txt
##                           -------------------
##    begin                : Sat Dec 06 2008
##    copyright            : (C) 2008 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_goto_common_LIB_SRCS
    GotoDialog.cpp
    GotoPluginBase.cpp
)

SET(plugin_goto_common_LIB_UI
    GotoDlg.ui
)

KI18N_WRAP_UI(plugin_goto_common_LIB_SRCS ${plugin_goto_common_LIB_UI})
ADD_LIBRARY(plugin_goto_common STATIC ${plugin_goto_common_LIB_SRCS})
SET_TARGET_PROPERTIES(plugin_goto_common PROPERTIES ENABLE_EXPORTS ON)
ADD_DEPENDENCIES(plugin_goto_common libkwave libkwavegui)
TARGET_LINK_LIBRARIES(plugin_goto_common
    kwavegui
    kwave
    Qt5::Core
    Qt5::Widgets
    KF5::ConfigWidgets
    KF5::I18n
)

#############################################################################

SET(plugin_goto_LIB_SRCS
    GotoPlugin.cpp
)

SET(plugin_goto_LIBS plugin_goto_common)
KWAVE_PLUGIN(goto)

#############################################################################

SET(plugin_insert_at_LIB_SRCS
    InsertAtPlugin.cpp
)

SET(plugin_insert_at_LIBS plugin_goto_common)
KWAVE_PLUGIN(insert_at)

#############################################################################
#############################################################################

=== plugins/selectrange/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/selectrange/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_selectrange_LIB_SRCS
    SelectRangeDialog.cpp
    SelectRangePlugin.cpp
)

SET(plugin_selectrange_LIB_UI
    SelectRangeDlg.ui
)

KWAVE_PLUGIN(selectrange)

#############################################################################
#############################################################################

=== debian/changelog ===
kwave (20.12.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update upstream GPG signing key.
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Use /usr/share/dpkg/architecture.mk instead of manually querying for
    $DEB_HOST_ARCH_OS.
  * Rename lintian-overrides to kwave.lintian-overrides, to make it explicit
    which package it refers to.
  * Add the configuration for the CI on salsa.

 -- Pino Toscano <pino@debian.org>  Thu, 04 Feb 2021 15:15:30 +0100

kwave (20.12.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Add upstream metadata.
  * New upstream release (20.12.0).
  * Refresh copyright information.
  * Bump Standards-Version to 4.5.1, no change required.
  * Refresh upstream metadata.
  * Update project homepage.
  * Removed Mark Purcell from the uploaders, thanks for your work on the
    package!
  * Added myself to the uploaders.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 04 Jan 2021 22:45:08 +0100

kwave (20.08.2-1) unstable; urgency=medium

  * Team upload.
  * Add upstream tarball signature validation to watch file, borrow signing
    key from k3b.
  * New upstream release (20.08.2).
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.14.0
    - bump KF packages to 5.33.0
  * Build with hardening=+all build hardening flag.
  * Bump debhelper compatibility level to 13.
  * Migrate copyright information to DEP-5 machine readable format.

 -- Aurélien COUDERC <coucouf@debian.org>  Fri, 30 Oct 2020 17:46:17 +0100

=== debian/control ===
Source: kwave
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 2.8.12~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 1.7.0),
               gettext,
               libasound2-dev [linux-any],
               libaudiofile-dev (>> 0.3.0),
               libfftw3-dev,
               libflac++-dev (>= 1.1.4),
               libid3-3.8.3-dev (>= 3.8.3-4.2),
               libkf5completion-dev (>= 5.33.0~),
               libkf5config-dev (>= 5.33.0~),
               libkf5configwidgets-dev (>= 5.33.0~),
               libkf5coreaddons-dev (>= 5.33.0~),
               libkf5crash-dev (>= 5.33.0~),
               libkf5dbusaddons-dev (>= 5.33.0~),
               libkf5doctools-dev (>= 5.33.0~),
               libkf5i18n-dev (>= 5.33.0~),
               libkf5iconthemes-dev (>= 5.33.0~),
               libkf5kio-dev (>= 5.33.0~),
               libkf5service-dev (>= 5.33.0~),
               libkf5textwidgets-dev (>= 5.33.0~),
               libkf5widgetsaddons-dev (>= 5.33.0~),
               libkf5xmlgui-dev (>= 5.33.0~),
               libmad0-dev,
               libogg-dev,
               libopus-dev (>= 1.0.0),
               libpulse-dev,
               librsvg2-bin,
               libsamplerate0-dev,
               libvorbis-dev (>= 1.0.0-2),
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.14.0~),
               qtmultimedia5-dev (>= 5.14.0~)
Homepage: https://apps.kde.org/en/kwave
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kwave.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kwave
Rules-Requires-Root: no

Package: kwave
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: sound editor for KDE
 Kwave is a sound editor designed for the KDE Desktop Environment.
 .
 With Kwave you can record, play back, import and edit many sorts of audio
 files including multi-channel files.
 .
 Kwave includes some plugins to transform audio files in several ways and
 presents a graphical view with a complete zoom- and scroll capability.
 .
 Its features include:
  * 24 Bit Support
  * Undo/Redo
  * Use of multicore CPUs (SMP, hyperthreading)
  * Simple Drag & Drop
  * Realtime Pre-Listen for some effects
  * Support for multi-track files
  * Playback and recording via native ALSA, PulseAudio (or OSS deprecated)
  * Playback via Phonon
  * Load and edit-capability for large files (can use virtual memory)
  * Reading and auto-repair of damaged wav-files
  * Supports multiple windows
  * Extendable Plugin interface
  * a nice splashscreen
  * some label handling

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

ifneq ($(DEB_HOST_ARCH_OS),linux)
  DEB_CMAKE_CUSTOM_FLAGS += -DWITH_ALSA=OFF
endif

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DWITH_MP3=ON $(DEB_CMAKE_CUSTOM_FLAGS)

## kwave 20.12.3

=== debian/changelog ===
kwave (20.12.3-0ubuntu1) hirsute; urgency=medium

  * New upstream release (20.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 04 Mar 2021 15:27:40 +0000

## kwave 21.04.0

=== debian/changelog ===
kwave (21.04.0-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 29 Apr 2021 01:45:17 +0100

## kwave 21.08.1

=== debian/changelog ===
kwave (21.08.1-0ubuntu1) impish; urgency=medium

  * New upstream release (21.08.1)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Thu, 09 Sep 2021 22:39:44 +0100

kwave (21.08.0-0ubuntu1) impish; urgency=medium

  * New upstream release (21.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 12 Aug 2021 09:09:18 +0100

kwave (21.07.90-0ubuntu1) impish; urgency=medium

  * New upstream (RC) release (21.07.90)

 -- Rik Mills <rikmills@kde.org>  Mon, 02 Aug 2021 13:03:35 +0100

kwave (21.07.80-0ubuntu1) impish; urgency=medium

  * New upstream (beta) release (21.07.80)

 -- Rik Mills <rikmills@kde.org>  Sun, 18 Jul 2021 20:38:55 +0100

kwave (21.04.3-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Jul 2021 11:50:32 +0100

kwave (21.04.2-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 10 Jun 2021 10:47:50 +0100

kwave (21.04.1-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 13 May 2021 09:14:12 +0100

=== debian/control ===
--- 
+++ 
@@ -36,7 +36,7 @@
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
                qtbase5-dev (>= 5.14.0~),
-               qtmultimedia5-dev (>= 5.14.0~)
+               qtmultimedia5-dev (>= 5.14.0~),
 Homepage: https://apps.kde.org/en/kwave
 Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kwave.git

## kwave 21.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,9 +23,9 @@
 #############################################################################
 
 # KDE Application Version, managed by release script
-set (RELEASE_SERVICE_VERSION_MAJOR "20")
+set (RELEASE_SERVICE_VERSION_MAJOR "21")
 set (RELEASE_SERVICE_VERSION_MINOR "12")
-set (RELEASE_SERVICE_VERSION_MICRO "2")
+set (RELEASE_SERVICE_VERSION_MICRO "3")
 
 #############################################################################
 ### build options:                                                        ###
@@ -64,7 +64,7 @@
 #############################################################################
 ### required versions                                                     ###
 
-CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.16.0 FATAL_ERROR)
 
 # Honor visibility properties for all target types (since cmake 3.3)
 IF (POLICY CMP0063)

=== plugins/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

MACRO(KWAVE_PLUGIN _plugin)

    #########################################################################
    ### compile stage                                                     ###

    INCLUDE_DIRECTORIES(
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
    )
    KI18N_WRAP_UI(plugin_${_plugin}_LIB_SRCS ${plugin_${_plugin}_LIB_UI})

    #########################################################################
    ### link stage                                                        ###

    ADD_LIBRARY(plugin_${_plugin} MODULE ${plugin_${_plugin}_LIB_SRCS})
    TARGET_LINK_LIBRARIES(plugin_${_plugin}
        kwavegui
        kwave
        ${plugin_${_plugin}_LIBS}
        ${SAMPLERATE_LIBS}
        Qt5::Core
        Qt5::Concurrent
        Qt5::Widgets
        KF5::ConfigCore
        KF5::CoreAddons
        KF5::I18n
        KF5::IconThemes
        KF5::KIOFileWidgets
        KF5::Service
        KF5::TextWidgets
        KF5::WidgetsAddons
        KF5::XmlGui
    )

    SET_TARGET_PROPERTIES(plugin_${_plugin} PROPERTIES
        PREFIX "kwaveplugin_"
        OUTPUT_NAME "${_plugin}"
        LINK_FLAGS "-Wl,--export-dynamic"
        ENABLE_EXPORTS TRUE
    )
    SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

    CONFIGURE_FILE(
        ${CMAKE_CURRENT_SOURCE_DIR}/kwaveplugin_${_plugin}.desktop.in
        ${CMAKE_CURRENT_BINARY_DIR}/kwaveplugin_${_plugin}.desktop
    )

    KCOREADDONS_DESKTOP_TO_JSON(
        plugin_${_plugin}
        ${CMAKE_CURRENT_BINARY_DIR}/kwaveplugin_${_plugin}.desktop
        DEFAULT_SERVICE_TYPE Kwave/Plugin
    )

    #########################################################################
    ### install                                                           ###

    ADD_DEPENDENCIES(plugin_${_plugin} libkwave libkwavegui)

    INSTALL(TARGETS
        plugin_${_plugin}
        LIBRARY
        DESTINATION ${PLUGIN_INSTALL_DIR}/kwave
    )

ENDMACRO(KWAVE_PLUGIN)

INSTALL(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/kwave-plugin.desktop
    DESTINATION ${SERVICETYPES_INSTALL_DIR}
)

#############################################################################

ADD_SUBDIRECTORY( about )
ADD_SUBDIRECTORY( amplifyfree )
ADD_SUBDIRECTORY( band_pass )
ADD_SUBDIRECTORY( codec_ascii )
ADD_SUBDIRECTORY( codec_audiofile ) # needs libaudiofile
ADD_SUBDIRECTORY( codec_flac )      # needs >= libflac 1.2.0
ADD_SUBDIRECTORY( codec_mp3 )       # needs libmad + id3lib + "lame"
ADD_SUBDIRECTORY( codec_ogg )       # needs libogg and (libvorbis or libopus)
ADD_SUBDIRECTORY( codec_wav )       # needs libaudiofile
ADD_SUBDIRECTORY( debug )
ADD_SUBDIRECTORY( export_k3b )
ADD_SUBDIRECTORY( fileinfo )
ADD_SUBDIRECTORY( goto )
ADD_SUBDIRECTORY( lowpass )
ADD_SUBDIRECTORY( newsignal )
ADD_SUBDIRECTORY( noise )
ADD_SUBDIRECTORY( normalize )
ADD_SUBDIRECTORY( notch_filter )
ADD_SUBDIRECTORY( pitch_shift )
ADD_SUBDIRECTORY( playback )        # needs one of: OSS/ALSA/PulseAudio
ADD_SUBDIRECTORY( record )          # needs OSS and/or ALSA
ADD_SUBDIRECTORY( reverse )
ADD_SUBDIRECTORY( samplerate )      # needs libsamplerate
ADD_SUBDIRECTORY( saveblocks )
ADD_SUBDIRECTORY( selectrange )
ADD_SUBDIRECTORY( sonagram )        # needs fftw >= 3.0
ADD_SUBDIRECTORY( stringenter )
ADD_SUBDIRECTORY( volume )
ADD_SUBDIRECTORY( zero )

#############################################################################
#############################################################################

=== plugins/saveblocks/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/saveblocks/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_saveblocks_LIB_SRCS
    SaveBlocksDialog.cpp
    SaveBlocksPlugin.cpp
    SaveBlocksWidget.cpp
)

SET(plugin_saveblocks_LIB_UI
    SaveBlocksWidgetBase.ui
)

KWAVE_PLUGIN(saveblocks)

#############################################################################
#############################################################################

=== debian/changelog ===
kwave (21.12.3-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Mar 2022 10:17:36 +0000

kwave (21.12.2-0ubuntu1) jammy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * Update upstream signing key

  [ Rik Mills ]
  * New upstream release (21.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Feb 2022 07:24:11 +0000

kwave (21.12.1-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jan 2022 10:32:00 +0000

kwave (21.12.0-0ubuntu1) jammy; urgency=medium

  [ Rik Mills ]
  * New upstream release (21.12.0)
  * Set maintainer to Kubuntu Developers.

  [ José Manuel Santamaría Lema ]
  * Update upstream signing key

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Dec 2021 11:29:06 +0000

kwave (21.11.90-0ubuntu2) jammy; urgency=medium

  * Add Kubuntu Vcs fields.

 -- Rik Mills <rikmills@kde.org>  Sun, 28 Nov 2021 19:12:42 +0000

kwave (21.11.90-0ubuntu1) jammy; urgency=medium

  * New upstream (RC) release (21.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 26 Nov 2021 13:24:21 +0000

kwave (21.11.80-0ubuntu1) jammy; urgency=medium

  * New upstream (beta) release (21.11.80)

 -- Rik Mills <rikmills@kde.org>  Sun, 21 Nov 2021 18:31:36 +0000

kwave (21.08.3-0ubuntu1) jammy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * New upstream release (21.08.2)

  [ Rik Mills ]
  * New upstream release (21.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 15 Nov 2021 09:46:46 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: kwave
 Section: kde
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
 Build-Depends: cmake (>= 2.8.12~),
                debhelper-compat (= 13),
@@ -39,8 +40,8 @@
                qtmultimedia5-dev (>= 5.14.0~),
 Homepage: https://apps.kde.org/en/kwave
 Standards-Version: 4.5.1
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kwave.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kwave
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kwave
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kwave
 Rules-Requires-Root: no
 
 Package: kwave
